package com.bzd.web.controller.hygl;

import com.bzd.common.annotation.Log;
import com.bzd.common.config.dao.PageData;
import com.bzd.common.core.controller.BaseController;
import com.bzd.common.core.domain.AjaxResult;
import com.bzd.common.core.page.TableDataInfo;
import com.bzd.common.enums.BusinessType;
import com.bzd.system.service.PharmaceuticalService;
import org.apache.shiro.authz.annotation.RequiresPermissions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.ui.ModelMap;
import org.springframework.web.bind.annotation.*;
import com.bzd.system.service.hygl.SHyglHyxxJzyxMarketingplaninfoService;

import java.util.List;

/**
*
* 人群运营计划看板 前端控制器Controller
* @author LiXiangFei
* @since 2024-10-15
*/
@Controller
@RequestMapping(value = "hygl/shyglhyxxjzyxmarketingplaninfo")
public class SHyglHyxxJzyxMarketingplaninfoController extends BaseController {

    // 页面跳转前缀
    private String prefix = "hygl";

    @Autowired
    private SHyglHyxxJzyxMarketingplaninfoService sHyglHyxxJzyxMarketingplaninfoService;

    /**
    * 人群运营计划看板 新增页面跳转
    *
    * @return
    */
    @RequiresPermissions("hygl:hy:view")
    @GetMapping("/sHyglHyxxJzyxMarketingplaninfoAdd")
    public String add() {
        return prefix + "/SHyglHyxxJzyxMarketingplaninfoAdd";
    }

    /**
    * 人群运营计划看板 新增
    *
    * @return
    */
    @Log(title = "人群运营计划看板新增", businessType = BusinessType.INSERT)
    @PostMapping("/sHyglHyxxJzyxMarketingplaninfoAdd")
    @ResponseBody
    public AjaxResult addSave() throws Exception {
        PageData pd = this.getPageData();
        try {
            Integer result = sHyglHyxxJzyxMarketingplaninfoService.addSHyglHyxxJzyxMarketingplaninfo(pd);
            if (result == 1) {
                return AjaxResult.success("新增成功");
            } else {
                logger.error("Failed to update 表skccrkckreceiptinfo with ID: {}", pd.get("id"));
                return AjaxResult.error("新增失败");
            }
        } catch (Exception e) {
            logger.error("Error occurred while updating 表skccrkckreceiptinfo with ID: {}, Exception: {}", pd.get("id"), e.getMessage(), e);
            return AjaxResult.error("系统异常：" + e.getMessage());
        }
    }

    /**
    * 人群运营计划看板 查询页面跳转
    *
    * @return
    */
    @RequiresPermissions("hygl:hy:view")
    @GetMapping("/sHyglHyxxJzyxMarketingplaninfoView")
    public String shyglhyxxjzyxmarketingplaninfoListView() {
        return prefix + "/SHyglHyxxJzyxMarketingplaninfoList";
    }

    /**
    * 人群运营计划看板 数据查询
    *
    * @return
    * @throws Exception
    */
    @RequiresPermissions("hygl:hy:sHyglHyxxJzyxMarketingplaninfoList")
    @PostMapping("/sHyglHyxxJzyxMarketingplaninfoList")
    @ResponseBody
    public TableDataInfo shyglhyxxjzyxmarketingplaninfoList() throws Exception {
    PageData pd = this.getPageData();
    startPage();
    List<PageData> pageData = sHyglHyxxJzyxMarketingplaninfoService.findSHyglHyxxJzyxMarketingplaninfoList(pd);
        return getDataTable(pageData);
    }

    /**
    * 人群运营计划看板 数据删除 根据id
    *
    * @return
    * @throws Exception
    */
    @RequiresPermissions("hygl:hy:remove")
    @Log(title = "人群运营计划看板删除", businessType = BusinessType.DELETE)
    @PostMapping("/sHyglHyxxJzyxMarketingplaninfoRemove")
    @ResponseBody
    public AjaxResult shyglhyxxjzyxmarketingplaninfoRemove() throws Exception {
        PageData pd = this.getPageData();
        Integer integer = sHyglHyxxJzyxMarketingplaninfoService.SHyglHyxxJzyxMarketingplaninfoRemove(pd);
        return toAjax(integer);
    }

    /**
    * 人群运营计划看板 数据修改
    *
    * @return
    * @throws Exception
    */
    @RequiresPermissions("hygl:hy:edit")
    @GetMapping("/sHyglHyxxJzyxMarketingplaninfoEdit/{id}")
    public String shyglhyxxjzyxmarketingplaninfoView(@PathVariable("id") Long id, ModelMap mmap) throws Exception {
        PageData pd = this.getPageData();
        pd.put("id", id);
        PageData pageData = sHyglHyxxJzyxMarketingplaninfoService.findSHyglHyxxJzyxMarketingplaninfoList(pd).get(0);
        mmap.putAll(pageData);
        if(null!=pd.getString("status")){
            return prefix+ "/shyglhyxxjzyxmarketingplaninfoPageEdit";
        }
        return prefix+ "/shyglhyxxjzyxmarketingplaninfoEdit";
    }

    /**
    * 人群运营计划看板保存修改的数据
    */
    @RequiresPermissions("hygl:hy:edit")
    @Log(title = "人群运营计划看板修改", businessType = BusinessType.UPDATE)
    @PostMapping("/sHyglHyxxJzyxMarketingplaninfoEdit")
    @ResponseBody
    public AjaxResult shyglhyxxjzyxmarketingplaninfoEditSave() throws Exception {
        PageData pd = this.getPageData();
        pd.put("up", "up");
        try {
            Integer updateResult = sHyglHyxxJzyxMarketingplaninfoService.updateSHyglHyxxJzyxMarketingplaninfo(pd);
            if (updateResult == 1) {
                // 成功更新
                return AjaxResult.success("修改成功");
            } else {
                // 更新失败
                logger.error("Failed to update 表shyglhyxxjzyxmarketingplaninfo with ID: {}", pd.get("id"));
                return AjaxResult.error("修改失败");
            }
        } catch (Exception e) {
            // 异常处理
            logger.error("Error occurred while updating 表shyglhyxxjzyxmarketingplaninfo with ID: {}, Exception: {}", pd.get("id"), e.getMessage(), e);
            return AjaxResult.error("系统异常：" + e.getMessage());
        }
    }
}
